#include "led.h"
#include "delay.h"
#include "key.h"
#include "sys.h"
#include "lcd.h"
#include "usart.h"	
#include "timer.h"
#include "sram.h"
#include "malloc.h"
#include "string.h"
#include "usmart.h"	
#include "dm9000.h"
#include "lwip/netif.h"
#include "lwip_comm.h"
#include "lwipopts.h"
#include "includes.h"
#include "udp_demo.h"
/************************************************
 ALIENTEKսSTM32LWIPʵ
 NETCONN APIUDPʵ
 ֧֣www.openedv.com
 Ա̣http://eboard.taobao.com 
 ע΢Źƽ̨΢źţ"ԭ"ѻȡSTM32ϡ
 ӿƼ޹˾  
 ߣԭ @ALIENTEK
************************************************/

//KEY
#define KEY_TASK_PRIO 		9
//ջС
#define KEY_STK_SIZE		128	
//ջ
OS_STK KEY_TASK_STK[KEY_STK_SIZE];
//
void key_task(void *pdata);   

//LED
//ȼ
#define LED_TASK_PRIO		10
//ջС
#define LED_STK_SIZE		64
//ջ
OS_STK	LED_TASK_STK[LED_STK_SIZE];
//
void led_task(void *pdata);  

//LCDʾַϢ
//ȼ
#define DISPLAY_TASK_PRIO	11
//ջС
#define DISPLAY_STK_SIZE	128
//ջ
OS_STK	DISPLAY_TASK_STK[DISPLAY_STK_SIZE];
//
void display_task(void *pdata);

//START
//ȼ
#define START_TASK_PRIO		12
//ջС
#define START_STK_SIZE		128
//ջ
OS_STK START_TASK_STK[START_STK_SIZE];
//
void start_task(void *pdata); 
//LCDʾַϢ
//mode:1 ʾDHCPȡĵַ
//	   ʾַ̬
void show_address(u8 mode)
{
	u8 buf[30];
	if(mode==2)
	{
		sprintf((char*)buf,"DHCP IP :%d.%d.%d.%d",lwipdev.ip[0],lwipdev.ip[1],lwipdev.ip[2],lwipdev.ip[3]);						//ӡ̬IPַ
		LCD_ShowString(30,170,210,16,16,buf); 
		sprintf((char*)buf,"DHCP GW :%d.%d.%d.%d",lwipdev.gateway[0],lwipdev.gateway[1],lwipdev.gateway[2],lwipdev.gateway[3]);	//ӡصַ
		LCD_ShowString(30,190,210,16,16,buf); 
		sprintf((char*)buf,"NET MASK:%d.%d.%d.%d",lwipdev.netmask[0],lwipdev.netmask[1],lwipdev.netmask[2],lwipdev.netmask[3]);	//ӡַ
		LCD_ShowString(30,210,210,16,16,buf); 
		LCD_ShowString(30,230,210,16,16,"Port:8089!"); 
	}
	else 
	{
		sprintf((char*)buf,"Static IP:%d.%d.%d.%d",lwipdev.ip[0],lwipdev.ip[1],lwipdev.ip[2],lwipdev.ip[3]);						//ӡ̬IPַ
		LCD_ShowString(30,170,210,16,16,buf); 
		sprintf((char*)buf,"Static GW:%d.%d.%d.%d",lwipdev.gateway[0],lwipdev.gateway[1],lwipdev.gateway[2],lwipdev.gateway[3]);	//ӡصַ
		LCD_ShowString(30,190,210,16,16,buf); 
		sprintf((char*)buf,"NET MASK:%d.%d.%d.%d",lwipdev.netmask[0],lwipdev.netmask[1],lwipdev.netmask[2],lwipdev.netmask[3]);	//ӡַ
		LCD_ShowString(30,210,210,16,16,buf); 
		LCD_ShowString(30,230,210,16,16,"Port:8089!"); 
	}	
}


int main(void)
{	 
	delay_init();	    	//ʱʼ	  
	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2); 	//NVICжϷ2:2λռȼ2λӦȼ
	uart_init(115200);	 	//ڳʼΪ115200
 	LED_Init();			    //LED˿ڳʼ
	LCD_Init();				//ʼLCD
	KEY_Init();	 			//ʼ
 	usmart_dev.init(72);	//ʼUSMART		
 	FSMC_SRAM_Init();		//ʼⲿSRAM
	my_mem_init(SRAMIN);		//ʼڲڴ
	my_mem_init(SRAMEX);		//ʼⲿڴ
	POINT_COLOR = RED; 		
	LCD_ShowString(30,30,200,16,16,"WARSHIP STM32F103");
	LCD_ShowString(30,50,200,16,16,"UDP NETCONN Test");
	LCD_ShowString(30,70,200,16,16,"ATOM@ALIENTEK");
	LCD_ShowString(30,90,200,20,16,"KEY0:Send data");
	LCD_ShowString(30,110,200,20,16,"2015/3/21");	
	POINT_COLOR = BLUE; 	//ɫ
	 
	OSInit();				//UCOSʼ
	while(lwip_comm_init()) 	//lwipʼ
	{
		LCD_ShowString(30,130,200,20,16,"Lwip Init failed!"); 	//lwipʼʧ
		delay_ms(500);
		LCD_Fill(30,130,230,150,WHITE);
		delay_ms(500);
	}
	LCD_ShowString(30,130,200,20,16,"Lwip Init Success!"); 		//lwipʼɹ
	while(udp_demo_init()) 										//ʼudp_demo(udp_demo߳)
	{
		LCD_ShowString(30,150,200,20,16,"UDP failed!!"); 		//udpʧ
		delay_ms(500);
		LCD_Fill(30,150,230,170,WHITE);
		delay_ms(500);
	}
	LCD_ShowString(30,150,200,20,16,"UDP Success!"); 			//udpɹ
	OSTaskCreate(start_task,(void*)0,(OS_STK*)&START_TASK_STK[START_STK_SIZE-1],START_TASK_PRIO);
	OSStart(); //UCOS
}
 
//start
void start_task(void *pdata)
{
	OS_CPU_SR cpu_sr;
	pdata = pdata ;
	
	OSStatInit();  			//ʼͳ
	OS_ENTER_CRITICAL();  	//ж
	OSTaskCreate(led_task,(void*)0,(OS_STK*)&LED_TASK_STK[LED_STK_SIZE-1],LED_TASK_PRIO); 	//LED
	OSTaskCreate(key_task,(void*)0,(OS_STK*)&KEY_TASK_STK[KEY_STK_SIZE-1],KEY_TASK_PRIO); 	//KEY
	OSTaskCreate(display_task,(void*)0,(OS_STK*)&DISPLAY_TASK_STK[DISPLAY_STK_SIZE-1],DISPLAY_TASK_PRIO); //ʾ
	OSTaskSuspend(OS_PRIO_SELF); //start_task
	OS_EXIT_CRITICAL();  //ж
}

//ʾַϢ
void display_task(void *pdata)
{
	while(1)
	{ 
#if LWIP_DHCP									//DHCPʱ
		if(lwipdev.dhcpstatus != 0) 			//DHCP
		{
			show_address(lwipdev.dhcpstatus );	//ʾַϢ
			OSTaskSuspend(OS_PRIO_SELF); 		//ʾַϢ
		}
#else
		show_address(0); 						//ʾַ̬
		OSTaskSuspend(OS_PRIO_SELF); 			//ʾַϢ
#endif //LWIP_DHCP
		OSTimeDlyHMSM(0,0,0,500);
	}
}

//key
void key_task(void *pdata)
{
	u8 key; 
	while(1)
	{
		key = KEY_Scan(0);
		if(key==KEY0_PRES) //
		{
			udp_flag |= LWIP_SEND_DATA; //LWIPҪ
		}
		OSTimeDlyHMSM(0,0,0,10);  //ʱ10ms
	}
}

//led
void led_task(void *pdata)
{
	while(1)
	{
		LED0 = !LED0;
		OSTimeDlyHMSM(0,0,0,500);  //ʱ500ms
 	}
}
